/*
 * Marc 'BlackJack' Rintsch, 06.03.2001
 *
 * unsigned int cbm_load(const char* name,
 *                       unsigned char device,
 *                       const unsigned char* data);
 */
#include <stdio.h>
#include <cbm.h>

#include "simpleio.h"
#include "membankp4.h"

//#pragma code-name ("LOWCODE")

/* loads file "name" from given device to given address or to the load address
 * of the file if "data" is 0
 */
unsigned int bank1_cbm_load(const char* name, unsigned char device, void* data)
{
	/* LFN is set to 0 but it's not needed for loading.
	 * (BASIC V2 sets it to the value of the SA for LOAD) */
	static unsigned int i;
//putchar ('1');
	//cbm_k_setbnk (1, 0);
	cbm_k_setlfs(14, device, CBM_READ);
	// __asm__ (
		// "\tlda\t#0\n"
		// "\tsta\ttmp4\n"
		// //"\tldx\t%o\n"
		// "\tldy\t#%o\n"
		// "\tlda\t(sp),y\n"
		// "\ttax\n"
		// "\tldy\t#%o\n"
		// "\tlda\t(sp),y\n"
		// "\tiny\n"
		// "\tora\t(sp),y\n"
		// "\tbne\t@l2\n"
		// "\tldy\t#1\n"
		// "\tbne\t@l3\n"
		// "@l2:\n"
		// "\tldy\t#0\n"
		// "@l3:\n"
		// //"\tlda\t#<SETLFS\n"
		// //"\tjsr\tcallkernal\n"
		// "\tsta\t$FF3F\n"
		// "\tjsr\tSETLFS\n"
		// "\tsta\t$FF3E\n",
		// device, data
		// );
	cbm_k_setnam(name);
	i=cbm_k_open(); //if (i) return -1;
	//i=cbm_open (14, device, CBM_READ, name);
//printu(i); printcr();
	i=bank1_cbm_read (14, data, 0xFC00-(unsigned) data);
//putchar ('-');
	cbm_close (14);

	//i=(cbm_k_load(0, (unsigned int)data) - (unsigned int)data);
//printf ("ST: %d\n", cbm_k_readst());
	//return (cbm_k_load(0, (unsigned int)data));
	//i=(cbm_k_load(0, (unsigned int)data));
	//cbm_k_setbnk (0, 0);
//putchar ('3');
//putchar (13);
//getkey();
	return i;
}
